{$N+,E-,G+}
unit mndldemo;

INTERFACE
  procedure demoStart( dateiname: string );
  procedure ausblenden;

IMPLEMENTATION
uses
  graph, crt, wandler;
type
  realZahl = extended;
  kZahl = record
            a, b: realZahl;
          end;
  RGBfarben = record
                r, g, b: byte;
              end;
  farbPalette = array[0..255] of RGBfarben;
  posDat = record
             a, b, s: realZahl;
           end;
var
  maxFarb, genauigkeit, maxx, maxy: word;
  farbe: farbPalette;
  stelle: posDat;
  ticks: longint absolute $0000:$046C;
  oTicks: longint;

function echtFarb(farbNr: byte): byte;
begin
  if maxFarb = 16 then
    case farbNr of
      6: echtFarb:= 20;
      8..15: echtFarb:= (farbNr + 48);
     else echtFarb:= farbNr;
    end
  else echtFarb:= farbNr;
end;

procedure setRGB(farbNr, r, g, b: byte);
begin
  port[$3c8]:= echtFarb(farbNr);
  port[$3c9]:= r;
  port[$3c9]:= g;
  port[$3c9]:= b;
end;

procedure ausblenden;
var
  i, j: byte;
begin
  oticks:= ticks;
  maxFarb:= (getmaxcolor + 1);
  farbe[0].r:= 0; farbe[0].g:= 0; farbe[0].b:= 0;
  farbe[1].r:= 0; farbe[1].g:= 0; farbe[1].b:= 42;
  farbe[2].r:= 0; farbe[2].g:= 42; farbe[2].b:= 0;
  farbe[3].r:= 0; farbe[3].g:= 42; farbe[3].b:= 42;
  farbe[4].r:= 42; farbe[4].g:= 0; farbe[4].b:= 0;
  farbe[5].r:= 42; farbe[5].g:= 0; farbe[5].b:= 42;
  farbe[6].r:= 42; farbe[6].g:= 21; farbe[6].b:= 0;
  farbe[7].r:= 42; farbe[7].g:= 42; farbe[7].b:= 42;
  farbe[8].r:= 21; farbe[8].g:= 21; farbe[8].b:= 21;
  farbe[9].r:= 21; farbe[9].g:= 21; farbe[9].b:= 63;
  farbe[10].r:= 21; farbe[10].g:= 63; farbe[10].b:= 21;
  farbe[11].r:= 21; farbe[11].g:= 63; farbe[11].b:= 63;
  farbe[12].r:= 63; farbe[12].g:= 21; farbe[12].b:= 21;
  farbe[13].r:= 63; farbe[13].g:= 21; farbe[13].b:= 63;
  farbe[14].r:= 63; farbe[14].g:= 63; farbe[14].b:= 21;
  farbe[15].r:= 63; farbe[15].g:= 63; farbe[15].b:= 63;
  i:= 32;
  while i > 0 do
  begin
    if ticks > (oticks + 32 - i) then
    begin
      dec(i);
      for j:= 1 to 15 do
      with farbe[j] do
      begin
        if r > i * 2 then r:= i * 2;
        if g > i * 2 then g:= i * 2;
        if b > i * 2 then b:= i * 2;
        setrgb(j, r, g, b);
      end;
    end;
  end;
  for i:= 16 to 255 do
    with farbe[i] do
      setRGB(i, 0, 0, 0);
end;

function dateiOeffnen( dateiname: string ): boolean;
type
  pFarb256 = ^tFarb256;
  tFarb256 = record
               inhalt: farbPalette;
               vor: pFarb256;
             end;
  pFarb16 = ^tFarb16;
  tFarb16 = record
              inhalt: array[0..15] of RGBfarben;
              vor: pFarb16;
            end;
  pStelle = ^tStelle;
  tStelle = record
              inhalt: posDat;
              vor: pStelle;
            end;
var
  datei: text;
  zeile: string;
  section, i, j: byte;
  a256farb, l256farb, t256farb: pFarb256;
  a16farb, l16farb, t16farb: pFarb16;
  aStelle, lStelle, stelleT: pStelle;
  merker: pointer;
begin
  zeile:= '';
  assign(datei, dateiname);
  {$i-}
  reset(datei);
  {$i+}
  if ioresult = 0 then
  begin
    aStelle:= nil;
    a256farb:= nil;
    a16farb:= nil;
    lStelle:= aStelle;
    l256farb:= a256farb;
    l16farb:= a16farb;
    section:= 0;
    while not(eof(datei)) do
    begin
      readln( datei, zeile );
      if zeile <> '' then
      if zeile[1] <> '/' then
      if zeile[1] = '[' then inc(section) else
      if section = 1 then
      begin
        if zeile[1] = 'x' then
        begin
          new(stelleT);
          stelleT^.vor:= nil;
          delete(zeile,1,24);
          stelleT^.inhalt.a:= str2ext(zeile);
          readln(datei, zeile);
          delete(zeile,1,29);
          stelleT^.inhalt.b:= str2ext(zeile);
          readln(datei, zeile);
          delete(zeile,1,25);
          stelleT^.inhalt.s:= str2ext(zeile);
          if lStelle = nil then aStelle:= stelleT
                           else lStelle^.vor:= stelleT;
          lStelle:= stelleT;
        end;
      end
      else
      if section = 2 then
        if maxFarb <= 16 then
        begin
          if zeile = 'Farben: 16' then
          begin
            readln(datei, zeile);
            new(t16farb);
            t16farb^.vor:= nil;
            for i:= 0 to 15 do
              with t16farb^.inhalt[i] do
              begin
                readln(datei, zeile);
                r:= str2int( zeile[6] + zeile[7] + zeile[8] );
                g:= str2int( zeile[10] + zeile[11] + zeile[12] );
                b:= str2int( zeile[14] + zeile[15] + zeile[16] );
              end;
            if l16farb = nil then a16farb:= t16farb
                             else l16farb^.vor:= t16farb;
            l16farb:= t16farb;
          end;
        end
        else
        if zeile = 'Farben: 256' then
        begin
          readln(datei, zeile);
          new(t256farb);
          t256farb^.vor:= nil;
          for i:= 0 to 255 do
            with t256farb^.inhalt[i] do
            begin
              readln(datei, zeile);
              r:= str2int( zeile[6] + zeile[7] + zeile[8] );
              g:= str2int( zeile[10] + zeile[11] + zeile[12] );
              b:= str2int( zeile[14] + zeile[15] + zeile[16] );
            end;
          if l256farb = nil then a256farb:= t256farb
                            else l256farb^.vor:= t256farb;
          l256farb:= t256farb;
        end;
    end;
    close(datei);
    i:= 0;
    lStelle:= aStelle;
    while lStelle <> nil do
    begin
      lStelle:= lStelle^.vor;
      inc(i);
    end;
    lStelle:= aStelle;
    for j:= 1 to random(i) do lStelle:= lStelle^.vor;
    stelle.a:= lStelle^.inhalt.a;
    stelle.b:= lStelle^.inhalt.b;
    stelle.s:= lStelle^.inhalt.s;
    stelleT:= nil;
    lStelle:= aStelle;
    while lStelle <> nil do
    begin
      aStelle:= lStelle;
      lStelle:= lStelle^.vor;
      dispose(aStelle);
    end;
    aStelle:= nil;
    i:= 0;
    if maxFarb <= 16 then
    begin
      l16Farb:= a16Farb;
      while l16Farb <> nil do
      begin
        l16Farb:= l16Farb^.vor;
        inc(i);
      end;
      l16Farb:= a16Farb;
      for j:= 1 to random(i) do l16farb:= l16farb^.vor;
      for i:= 0 to 15 do
      begin
        farbe[i].r:= l16farb^.inhalt[i].r;
        farbe[i].g:= l16farb^.inhalt[i].g;
        farbe[i].b:= l16farb^.inhalt[i].b;
      end;
      l16farb:= a16farb;
      while l16farb <> nil do
      begin
        t16farb:= l16farb;
        l16farb:= l16farb^.vor;
        dispose(t16farb);
      end;
    end
    else
    begin
      l256Farb:= a256Farb;
      while l256Farb <> nil do
      begin
        l256Farb:= l256Farb^.vor;
        inc(i);
      end;
      l256Farb:= a256Farb;
      for j:= 1 to random(i) do l256farb:= l256farb^.vor;
      for i:= 0 to 255 do
      begin
        farbe[i].r:= l256farb^.inhalt[i].r;
        farbe[i].g:= l256farb^.inhalt[i].g;
        farbe[i].b:= l256farb^.inhalt[i].b;
      end;
      l256farb:= a256farb;
      while l256farb <> nil do
      begin
        t256farb:= l256farb^.vor;
        dispose(l256farb);
        l256farb:= t256farb;
      end;
    end;
    dateiOeffnen:= TRUE;
  end
  else dateiOeffnen:= FALSE;
end;

procedure einblenden(helligkeit: byte);
var
  i, neuR, neuG, neuB: byte;
begin
  for i:= 0 to (maxfarb - 1) do
    if i <> 15 then
      with farbe[i] do
      begin
        if r >= helligkeit then neuR:= helligkeit else neuR:= r;
        if g >= helligkeit then neuG:= helligkeit else neuG:= g;
        if b >= helligkeit then neuB:= helligkeit else neuB:= b;
        setRGB(i, neuR, neuG, neuB);
      end;
end;

function pixelFarbe(x:word):byte;
var
  f: word;
begin
  if x >= genauigkeit then f:= 0 else
    if trunc(x / (maxfarb-3)) mod 2 = 0 then f:=(x mod (maxfarb-3) + 1)
      else f:=(((maxfarb - 2) - x mod (maxfarb - 3)));
  if maxFarb > 16 then if f = 15 then f:= (maxFarb - 1);
  pixelFarbe:= f;
end;

procedure berechne(xpos, ypos: word);
var
  c, z: kZahl;
  zaehler: word;
  spalt: realZahl;
  procedure kQuadriere(var z: kZahl);
  var
    hilf: kZahl;
  begin
    hilf.a:= (sqr(z.a) - sqr(z.b));
    hilf.b:= (2 * z.a * z.b);
    z:= hilf;
  end;
begin
  spalt:= (stelle.s / maxy);
  c.a:= (xpos * spalt + stelle.a);
  c.b:= ((maxy - ypos) * spalt + stelle.b);
  z.a:= 0;
  z.b:= 0;
  zaehler:= 0;
  repeat
    inc(zaehler);
    kQuadriere(z);
    z.a:= z.a + c.a;
    z.b:= z.b + c.b;
  until ((zaehler > genauigkeit) or (sqrt(sqr(z.a) + sqr(z.b)) > 2));
  putpixel(xpos, ypos, pixelFarbe( zaehler ));
end; {berechne}

  procedure paletteAusgeben;
  var
    i, j, k, spalten, hoehe, breite: byte;
  begin
    spalten:= round(sqrt(getmaxcolor));
    hoehe:= maxy div spalten;
    breite:= maxx div spalten;
    k:= 0;
    for j:= 0 to (spalten-1) do
    for i:= 0 to (spalten-1) do
    begin
      setfillstyle(1,k);
      bar(i * breite, j * hoehe, (i + 1) * breite, (j + 1) * hoehe);
      inc(k);
    end;
  end;

procedure demoStart( dateiname: string );
var
  ende, end2: boolean;
  r, g, b: byte;
  tickCount, rechenCount: word;
  procedure textblenden(helligkeit: byte);
  begin
    setRGB( 15, helligkeit, helligkeit, helligkeit );
  end;
  procedure weiterrechnen;
  var
    j: word;
  begin
    if odd(rechencount) then
     for j:= 0 to maxx do berechne(j, rechencount div 2) else
      for j:= 0 to maxx do berechne(j, maxy - rechencount div 2);
    inc(rechencount);
  end;
begin
  randomize;
  ende:= FALSE;
  end2:= FALSE;
  maxx:= getmaxx;
  maxy:= getmaxy;
  if dateiOeffnen( dateiname ) then
  begin
    stelle.a:= (stelle.a - (stelle.s * maxx / maxy) / 2); {Umrechnen Mittelpunkt auf Ecke}
    stelle.b:= (stelle.b - stelle.s / 2);
    if stelle.s > 1 then genauigkeit:= 200
    else if stelle.s > 0.01 then genauigkeit:= 500
    else if stelle.s > 0.001 then genauigkeit:= 1000
    else genauigkeit:= 2000;
    cleardevice;
  end
  else ende:= TRUE;
{  paletteAusgeben;
  einblenden(63);
  readln;}
  outtextxy((maxx - 23 * 8) div 2, maxy div 2 - 2, 'Do you know MandelZoom?');
  rechenCount:= 0;
  tickCount:= 0;
  oTicks:= ticks;
  while not(ende or end2) do
  begin
    if keypressed then ende:= TRUE;
    if ticks > oticks + tickCount then
    begin
      tickCount:= ticks - oticks;  {1. Spruch einblenden}
      if tickCount <= 63 then textblenden(tickCount) else
        if tickCount >= 100 then
            if tickCount > 163 then end2:= true else
              textblenden(163 - tickCount);
    end;
    if rechencount < (maxy - 10) then weiterrechnen;
  end;
  setfillstyle(1, 0);
  bar(0, (maxy div 2 - 2), maxx, (maxy div 2 + 5));
  repeat
    if ticks > oticks + tickCount then
    begin
      tickCount:= ticks - oticks;
    end;
    if keypressed then ende:= TRUE;
  until ende or (tickCount > 200);
  end2:= false;
  outtextxy((maxx - 26 * 8) div 2, maxy div 2 - 2, 'Here comes a demo screen...');
  while not(ende or end2) do
  begin
    if keypressed then ende:= TRUE;
    if ticks > oticks + tickCount then
    begin
      tickCount:= ticks - oticks;
      if tickCount <= 263 then textblenden(tickCount - 200) {2. Spruch einblenden}
      else if (tickCount >= 300) and (tickCount <= 363) then
             textblenden(363 - tickCount);
    end;
    if tickCount > 337 then
    begin
      if tickCount <= 400 then
        einblenden(tickCount - 337) else end2:= true;
      if (rechencount > maxy - 11) and (rechencount <= maxy) then weiterrechnen;
    end;
    if rechencount < (maxy - 10) then weiterrechnen;
  end;
  textBlenden(0);
  while not(ende) and (rechencount <= maxy) do
  begin
    weiterrechnen;
    if keypressed then ende:= true;
  end;
  if not(ende) then readln;
end;

end.
{$N-,E+,G-}