unit nibbserv;
INTERFACE
  function int2str(zahl: integer): string;
  function str2int(zk: string): integer;
  function gr(zeichenkette: string): string;
  function zeilenEndWert(var zeile: string): integer;
  procedure csrOn;
  procedure csrOff;
  function erweiterung(name: string; soll: string): string;
  function nurName(name: string): string;
  function txtLaenge(zk: string; laenge: byte): string;

IMPLEMENTATION

Procedure CsrON;Assembler;
asm
  mov ah,01h
  mov ch,6
  mov cl,7
  int 10h
end;

Procedure CsrOFF;Assembler;
asm
  mov ah,01h
  mov ch,7
  mov cl,0
  int 10h
end;

function int2str(zahl: integer): string;
var
  zk: string[5];
begin
  str(zahl, zk);
  int2str:= zk;
end;

function str2int(zk:string):integer;
var
  code,zahl:integer;
begin
  val(zk,zahl,code);
  if code = 0 then str2int:= zahl else str2int:= 0;
end;

function gr(zeichenkette:string): string;
var
  i: byte;
begin
  for i := 1 to length(zeichenkette) do
    zeichenkette[i]:=UpCase(zeichenkette[i]);
  gr:=zeichenkette;
end;

function zeilenEndWert(var zeile: string): integer;
var
  i: byte;
  temp: string;
begin
  i:= length(zeile);
  while ((zeile[i] = ' ') and (i > 0)) do dec(i);
  delete(zeile, (i + 1), (length(zeile) - i)); {Leerzeichen am Ende lschen}
  i:= length(zeile);
  while ((zeile[i] <> ' ') and (zeile[i] <> '=') and (i > 0)) do dec(i);
  temp:= zeile;                         {Zeile zerlegen in Rest + EndWert}
  if i = 0 then zeile:= '' else delete(zeile, i, (length(zeile) - i + 1));
  delete(temp, 1, i);
  zeilenEndWert:= str2int(temp);
end;

function erweiterung(name: string; soll: string): string;
var
  i: byte;
  so_lassen: boolean;
begin
  so_lassen:= true;
  for i:=0 to (length(soll)-1) do
    if upcase(name[length(name) - i]) <> upcase(soll[length(soll) - i])
    then so_lassen:= false;
  for i:= length(name) downto 0 do {2 Punkte im Dateinamen erlaubt DOS nicht}
    if name[i] = '.' then so_lassen:= true;
  if so_lassen then erweiterung:= name else
  begin
    if length(name) > 8 then delete(name,9,length(name));
    erweiterung:= (name + soll);
  end;
end;

function nurName(name: string): string;
var
  hilf: string;
  i: byte;
begin
  hilf:= '';
  i:= length(name);
  if name <> '' then
  repeat
    if name[i] = '.' then hilf:='' else hilf:= name[i] + hilf;
    dec(i);
  until ((name[i] = '\') or (i = 0));
  nurName:= hilf;
end;

function txtLaenge(zk: string; laenge: byte): string;
begin
  if length(zk) > laenge then delete(zk, (laenge + 1), (length(zk) - laenge));
  while length(zk) < laenge do zk:= zk + ' ';
  txtLaenge:= zk;
end;

end.